; 
    include \masm32\include\masm32rt.inc
    .686
    .xmm
    include timers.asm

; 

; Thanks to: 
;  Mark Larson (for helping me optimizing the macros)

; This program uses the ranrot functions of Agner Fog (modified for the purpose of benchmarking)
;
; Original license text:
;  This random number generator software is copyrighted  2002-2005 by Agner Fog.
;  The software may be copied and used freely under the conditions of the GNU General
;  Public License with the following additional ethical constraint:
;
; This software shall not be used for any gambling application that is suitable
; for the exploitation of persons with ludomania for economic profit.
;
; Commercial licences are available on request. 

; WRandomInit must be called before the first call to any of the random
; functions.
; WRandom returns a floating point number between 0 and 1.
; WBRandom returns an integer between 0 and 0xFFFFFFFF
; WIRandom returns an integer in the interval

; Generates a 64-bit uniform random number
; Uses registers EAX-EDX
; Result in EDX:EAX
M_WBRandomSSE MACRO

	mov ebx, psse1
	mov ecx, psse2
	movapd xmm0, [randbufsse][ebx]
	movapd xmm1, [randbufsse][ebx+16]
	movapd xmm2, xmm0
	movapd xmm3, xmm1
	pslld xmm0, R1SSE
	pslld xmm1, R2SSE
	psrld xmm2, 32-R1SSE
	psrld xmm3, 32-R2SSE
	por xmm0, xmm2
	por xmm1, xmm3
	paddd xmm0, [randbufsse][ecx]
	paddd xmm1, [randbufsse][ecx+16]
	movapd [randbufsse][ebx], xmm1
	movapd [randbufsse][ebx+16], xmm0
	sub ebx, 16
	jnc @F
	mov ebx, (KKSSE-1)*32
@@:
	sub ecx, 16
	jnc @F
	mov ecx, (KKSSE-1)*32
@@:
	mov psse1, ebx
	mov psse2, ebx

ENDM

M_WBRandomSSEL MACRO

	mov ebx, psse1
	mov ecx, psse2
	movapd xmm0, [randbufsse][ebx]
	movapd xmm1, [randbufsse][ebx+16]
	movapd xmm2, xmm0
	movapd xmm3, xmm1
	pslld xmm0, R1SSE
	pslld xmm1, R2SSE
	psrld xmm2, 32-R1SSE
	psrld xmm3, 32-R2SSE
	por xmm0, xmm2
	por xmm1, xmm3
	paddd xmm0, [randbufsse][ecx]
	paddd xmm1, [randbufsse][ecx+16]
	movapd [randbufsse][ebx], xmm1
	movapd [randbufsse][ebx+16], xmm0
	mov ebx,[PtrNextSSE+ebx*4]
	mov ecx,[PtrNextSSE+ecx*4]
	mov psse1, ebx
	mov psse2, ebx

ENDM

M_WBRandomSSE2 MACRO

local skip

	cmp lastvaluesse, 0
	jz @F
	
	movapd xmm0, lastvaluesse
	mov lastvaluesse, 0
	jmp skip

@@:
	M_WBRandomSSE

	movapd lastvaluesse, xmm1
skip:

ENDM

M_WBRandomSSE2L MACRO

local skip

	cmp lastvaluesse, 0
	jz @F
	
	movapd xmm0, lastvaluesse
	mov lastvaluesse, 0
	jmp skip

@@:
	M_WBRandomSSEL

	movapd lastvaluesse, xmm1
skip:

ENDM



;M_WIRandom MACRO min:req, max:req
;
;	M_WBRandom
;	
;	MOV EBX, max - min + 1
;	MOV ECX, EDX             ; high bits of random number
;	MUL EBX                  ; multiply low 32 bits
;	MOV EAX, ECX
;	MOV ECX, EDX
;	MUL EBX                  ; multiply high 32 bits
;	ADD EAX, ECX
;	ADC EDX, min       ; add min
;	MOV EAX, EDX
;
;ENDM
;
M_WDRandomSSE MACRO

	M_WBRandomSSE2
	
	movapd xmm1, double_mask
	movapd xmm2, double_set
	movapd xmm3, double_one
	
	pand xmm0, xmm1
	por xmm0, xmm2
	subpd xmm0, xmm3

ENDM

M_WSRandomSSE MACRO

	M_WBRandomSSE2
	
	movapd xmm1, single_mask
	movapd xmm2, single_set
	movapd xmm3, single_one
	
	pand xmm0, xmm1
	por xmm0, xmm2
	subps xmm0, xmm3

ENDM

JJSSE      equ     10            ; lag 1
KKSSE      equ     17            ; lag 2, size of circular buffer
R1SSE      equ     19            ; rotate count
R2SSE      equ     27            ; rotate count

.data

align 16
psse1      DD      0             ; pointer in circular buffer
psse2      DD      0             ; pointer in circular buffer

align 16
randbufsse 	DD  (8*KKSSE) dup(?) ; circular buffer

align 16
tmpdouble 	REAL8 1.0
tmpdouble2	REAL8 1.0

double_one	REAL8	1.0, 1.0
double_mask	DD 0FFFFFFFFh, 000FFFFFh, 0FFFFFFFFh, 000FFFFFh
double_set	DD 0, 3FF00000h, 0, 3FF00000h;0, 3F800000h, 0, 3F800000h

align 16
tmpsingle		REAL4	1.0
tmpsingle2	REAL4	1.0
tmpsingle3	REAL4	1.0
tmpsingle4	REAL4	1.0

single_one	REAL4	1.0, 1.0, 1.0, 1.0
single_mask	DD 007FFFFFh, 007FFFFFh, 007FFFFFh, 007FFFFFh
single_set	DD 3F800000h, 3F800000h, 3F800000h, 3F800000h

; Lookup table for M_WRandomL - uses 516 bytes
align 16
PtrNextSSE label dword
	dd 32 dup(32*(KKSSE-1))
	
	counter = 0
  	REPEAT ((KKSSE-1)*32)-1
    	dd counter
			counter = counter + 1
   	endm

; Used by M_WRandom2
align 16
	lastvaluesse	dd 0,0,0,0
	sseout				dd 0,0,0,0

.code
start:
	rdtsc
	push eax
	call WRandomInitSSE	; Init to something
	
	M_WBRandomSSE
	movapd sseout, xmm0
	print hex$([sseout])
	print hex$([sseout+4])
	print hex$([sseout+8])
	print hex$([sseout+12])
	print "\",13,10
	movapd sseout, xmm1
	print hex$([sseout])
	print hex$([sseout+4])
	print hex$([sseout+8])
	print hex$([sseout+12])
	print " (WBRandomSSE)",13,10
	
	M_WBRandomSSEL
	movapd sseout, xmm0
	print hex$([sseout])
	print hex$([sseout+4])
	print hex$([sseout+8])
	print hex$([sseout+12])
	print "\",13,10
	movapd sseout, xmm1
	print hex$([sseout])
	print hex$([sseout+4])
	print hex$([sseout+8])
	print hex$([sseout+12])
	print " (WBRandomSSE, lookup)",13,10
	
	M_WBRandomSSE2
	movapd sseout, xmm0
	print hex$([sseout])
	print hex$([sseout+4])
	print hex$([sseout+8])
	print hex$([sseout+12])
	print " (WBRandomSSE, 128 bit)",13,10
	
	M_WBRandomSSE2L
	movapd sseout, xmm0
	print hex$([sseout])
	print hex$([sseout+4])
	print hex$([sseout+8])
	print hex$([sseout+12])
	print " (WBRandomSSE, 128 bit, lookup)",13,10
	
	M_WDRandomSSE
	movapd tmpdouble, xmm0
	print real8$(tmpdouble)
	print " ",13,10
	print real8$(tmpdouble2)
	print " (WDRandomSSE, 2 doubles)",13,10
	
	M_WSRandomSSE
	movapd tmpsingle, xmm0
	print real4$(tmpsingle)
	print " ",13,10
	print real4$(tmpsingle2)
	print " ",13,10
	print real4$(tmpsingle3)
	print " ",13,10
	print real4$(tmpsingle4)
	print " (WSRandomSSE, 4 singles)",13,10
	
	counter_begin 10000000, HIGH_PRIORITY_CLASS
	
	M_WBRandomSSE
	
	counter_end
	print ustr$(eax)
	print " cycles, WBRandom SSE",13,10
	
	counter_begin 10000000, HIGH_PRIORITY_CLASS
	
	M_WBRandomSSEL
	
	counter_end
	print ustr$(eax)
	print " cycles, WBRandom SSE, lookup",13,10
	
	counter_begin 10000000, HIGH_PRIORITY_CLASS
	
	M_WBRandomSSE2
	
	counter_end
	print ustr$(eax)
	print " cycles, WBRandom SSE, 128 bit",13,10
	
	counter_begin 10000000, HIGH_PRIORITY_CLASS
	
	M_WBRandomSSE2L
	
	counter_end
	print ustr$(eax)
	print " cycles, WBRandom SSE, 128 bit, lookup",13,10
	
	counter_begin 10000000, HIGH_PRIORITY_CLASS
	
	M_WDRandomSSE
	
	counter_end
	print ustr$(eax)
	print " cycles, WDRandom SSE, 2 doubles",13,10
	
	counter_begin 10000000, HIGH_PRIORITY_CLASS
	
	M_WSRandomSSE
	
	counter_end
	print ustr$(eax)
	print " cycles, WSRandom SSE, 4 singles",13,10
	
	inkey "Press any key to exit..."
	exit

WRandomInitSSE PROC seed:DWORD

	mov eax, seed
	xor ecx, ecx
_loop:
	imul eax, 2891336453
	add eax, 1
	mov [randbufsse][ecx*4], eax
	add ecx, 1
	cmp ecx, KKSSE*8
	jb _loop
	
	mov psse1, 0
	mov psse2, JJSSE*32
	
	M_WBRandomSSE
	
	push edi
	mov edi, 30
	
_initloop:
	M_WBRandomSSE
	sub edi, 1
	jnz _initloop
	
	pop edi
	ret
WRandomInitSSE ENDP

end start
